function ajaxSyncRequest(surl, params) {
    var xmlHttp = null,
        paramString = '?',
        key;

    params.a = Math.random();

    for (key in params) {
        paramString += key + '=' + encodeURIComponent(params[key]) + '&';
    }

    if (XMLHttpRequest !== undefined) {
        xmlHttp = new XMLHttpRequest();
    }
    if (!xmlHttp) {
        try {
            xmlHttp  = new ActiveXObject('Msxml2.XMLHTTP');
        } catch(e) {
            try {
                xmlHttp  = new ActiveXObject('Microsoft.XMLHTTP');
            } catch(f) {
                xmlHttp  = null;
            }
        }
    }
    if (xmlHttp) {
        xmlHttp.open('GET', surl + paramString, false);
        xmlHttp.send(null);
        return xmlHttp.responseText;
    }
}

function ajaxAssyncRequestWithoutAnswer(surl,params) {
    var xmlHttp = null,
        paramString = '?',
        key;

    params.a = Math.random();

    for (key in params) {
        paramString += key + '=' + encodeURIComponent(params[key]) + '&';
    }

    if (XMLHttpRequest !== undefined) {
        xmlHttp = new XMLHttpRequest();
    }
    if (!xmlHttp) {
        try {
            xmlHttp  = new ActiveXObject('Msxml2.XMLHTTP');
        } catch(e) {
            try {
                xmlHttp  = new ActiveXObject('Microsoft.XMLHTTP');
            } catch(f) {
                xmlHttp  = null;
            }
        }
    }
    if (xmlHttp) {
        xmlHttp.open('GET', surl+paramString,true);
        xmlHttp.send(null);
    }
}

function setProperty(sProp,sValue) {
    var sURL = '',
        sPath = escape(sProp);

    if (typeof(sValue) == 'number') {
        sURL = '/json/property/setInteger';
    } else if (typeof(sValue) == 'boolean') {
        sURL = '/json/property/setBoolean';
    } else {
        sURL = '/json/property/setString';
    }
    ajaxAssyncRequestWithoutAnswer(sURL, {'path': sPath,'value': (sValue)});
}

function setPropertyArchive(sProp) {
    var sURL = '/json/property/setFlag',
        sPath = escape(sProp);
    ajaxAssyncRequestWithoutAnswer(sURL, {'path': sPath,'value': 'true','flag':'ARCHIVE'});
}

function removeProperty(sProp) {
    var sURL = '/json/property/remove',
        sPath = escape(sProp);
    ajaxAssyncRequestWithoutAnswer(sURL, {'path': sPath});
}

function getProperty(prop, type) {
    var sURL = '/json/property/',
        sPath = escape(prop),
        obj;
    switch (type) {
        case 'boolean': sURL += 'getBoolean'; break;
        case 'integer': sURL += 'getInteger'; break;
        default: sURL += 'getString';
    }
    try {
        obj = ajaxSyncRequest(sURL, {'path': sPath});
        obj = JSON.parse(obj);
        if (obj.ok) {
            return obj.result.value;
        }
    } catch (e) { }
    return null;
}

function getPropertyString(sProp) {
    return getProperty(sProp, 'string');
}

function getPropertyInteger(sProp) {
    return getProperty(sProp, 'integer');
}

function getPropertyBoolean(sProp) {
    return getProperty(sProp, 'boolean');
}

function raiseEvent(name,params) {
    var sURL='/json/event/raise',
        paramString = '',
        key;

    for (key in params) {
        paramString += key + '=' + encodeURIComponent(params[key]) + ';';
    }
    ajaxAssyncRequestWithoutAnswer(sURL,{'name':name,'parameter':paramString.substr(0,paramString.length-1)});
}

// GLOBALS
var oDSMArray=[];

function checkMac() {
    return true;
}

function openMyenersave() {
    window.open('http://data.myenersave.com/fetcher/bind?mfg=digitalStrom&model=dss11&did=' + document.getElementById('registerInput').value,'mywindow','');
}

function promptReload() {
    var c = document.getElementById('page_content'),
        e = document.createElement('div');

    e.innerHTML = '<p style="color:red; font-weight:bold">'
                  + "Error while loading - the dSS might not be ready yet. This page will reload in ten seconds"
                  + '<br><br>'
                  + "Fehler beim laden - der dSS ist eventuell noch nicht bereit. Die Seite wird in zehn Sekunden neu geladen";

    c.parentNode.appendChild(e);
    c.parentNode.removeChild(c);
    setTimeout(location.reload, 10000);
}

function initValues()
{
    var sLocale = getPropertyString('/system/language/locale'),
        sHideClass = (sLocale && sLocale.substr && sLocale.substr(0, 2) === 'de') ? '.lang_en' : '.lang_de',
        // api key
        sApiKey = getPropertyString('/scripts/myenersave/apiKey'),
        // query system dsm
        oParameterDSM = { 'query' : '/apartment/dSMeters/*(dSUID,name,present)/capabilities(metering)' },
        sResDSM = ajaxSyncRequest("/json/property/query", oParameterDSM),
        oResDSM,
        oArray,
        // query dsm known to this script
        oParameterScript = { 'query' : '/scripts/myenersave/dSM/*(dSUID,enabled)' },
        sResScript = ajaxSyncRequest("/json/property/query", oParameterScript),
        oResScript,
        oScriptArray,
        // fetch mac address
        sNetStat = ajaxSyncRequest("/cgi-bin/netinfo.sh", {}),
        oNetStat,
        sMac,
        // other vars
        hasPresentDSM = false,
        sString = '<ul style="padding-left:0;">',
        sChecked = '',
        htmlNode,
        i = 0;

    if (document.styleSheets[0].addRule) {
        // thank you microsoft
        document.styleSheets[0].addRule(sHideClass, 'display: none');
    } else {
        document.styleSheets[0].insertRule(sHideClass +' {display: none}', 0);
    }

    try {
        oResDSM = JSON.parse(sResDSM);
        oArray = oResDSM.result.dSMeters;
        oResScript = JSON.parse(sResScript);
        oScriptArray = oResScript.result.dSM;
        oNetStat = JSON.parse(sNetStat);
    } catch(e) {
        // JSON parse exception
        promptReload();
        return;
    }

    sMac = oNetStat.data.mac.replace(/:/g, '');
    document.getElementById('registerInput').value = sMac;

    if (sApiKey !== null) {
        document.getElementById('apikeyInput').value = sApiKey;
        check();
    }

    for (i = 0; i < oArray.length; ++i) {
        var curDSM = oArray[i],
            isEnabled = true,
            j = 0;

        if ( (curDSM.present) && (curDSM.capabilities[0].metering) ){
            hasPresentDSM = true;
            oDSMArray.push(curDSM.dSUID);

            if (oScriptArray) {
                for (j = 0; j < oScriptArray.length; ++j) {
                    var cur = oScriptArray[j];
                    if (curDSM.dSUID == cur.dSUID) {
                        isEnabled = cur.enabled;
                        break;
                    }
                }
            }

            sString += '<li>';
            sChecked = '';
            if (isEnabled) {
                sChecked = ' checked="checked"';
            }
            sString += '<input' +sChecked+ ' type="checkbox" id="dSM_'+ curDSM.dSUID +'">';
            sString += '<label for="dSM_' + curDSM.dSUID + '">';
            if (curDSM.name) {
                sString += curDSM.name;
                sString += ' <span style="color: grey">('+ curDSM.dSUID +')</span>';
            } else {
                sString += curDSM.dSUID;
            }
            sString += '</label>';
            sString += '</li>';
        }
    }

    if (!hasPresentDSM && oArray.length > 0 && !oScriptArray) {
        // there are dsm but none dsm is present, couldn't load script node either -> dSS not ready
        promptReload();
        return;
    }

    sString += '</ul>';
    sString += '<div class="lang_en"><input type="button" onclick="setDSM();" value="Save"></div>';
    sString += '<div class="lang_de"><input type="button" onclick="setDSM();" value="Speichern"></div>';
    htmlNode = document.getElementById('dSMContainer');
    htmlNode.innerHTML = sString;
}

function setDSM()
{
    var i = 0,
        control;

    for (i = 0; i < oDSMArray.length; ++i) {
        control=document.getElementById('dSM_' + oDSMArray[i]);
        setProperty('/scripts/myenersave/dSM/' + oDSMArray[i] + '/dSUID', oDSMArray[i]);
        setPropertyArchive('/scripts/myenersave/dSM/' + oDSMArray[i] + '/dSUID',true);
        setProperty('/scripts/myenersave/dSM/' + oDSMArray[i] + '/enabled', control.checked);
        setPropertyArchive('/scripts/myenersave/dSM/' + oDSMArray[i] + '/enabled', true);
    }
    raiseEvent('myenersave', {'actions':'save'});
}

function check()
{
    var inputElement = document.getElementById('apikeyInput'),
        buttonElement = document.getElementById('apikeyButton');

    if (inputElement.value.length === 0) {
        return;
    }

    if (inputElement.value.length == 16) {
        buttonElement.disabled = '';
        inputElement.style.color = '#000000';
    } else {
        buttonElement.disabled = 'disabled';
        inputElement.style.color = '#ff0000';
    }
}

function startRegistration()
{
    var inputElement = document.getElementById('apikeyInput'),
        buttonElement = document.getElementById('apikeyButton'),
        oParameter = {
            actions: 'prepare',
            apikey: inputElement.value
        };

    if (inputElement.value.length != 16) {
        buttonElement.disabled = 'disabled';
        inputElement.style.color = '#ff0000';
        return;
    }
    raiseEvent('myenersave', oParameter);
    alert("Token saved - Token gespeichert");
}
